﻿Imports System.Globalization
Module modMain
    Const DEFAULT_COUNTRY = "United States"
    Public Function GenNumber(ByVal MaxNumber As Integer, _
    Optional ByVal MinNumber As Integer = 0) As String
        Try
            'initialize random number generator
            Dim r As New Random(System.DateTime.Now.Millisecond)

            'if passed incorrect arguments, swap them
            'can also throw exception or return 0
            If MinNumber > MaxNumber Then
                Dim t As Integer = MinNumber
                MinNumber = MaxNumber
                MaxNumber = t
            End If
            Return CStr(r.Next(MinNumber, MaxNumber))

        Catch ex As Exception
            MessageBox.Show("Random Number cannot be completed", "RandomNumber", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return ""
            Exit Function
        End Try
    End Function
    Public Sub Country_load(ByVal Country As ComboBox)
        Dim ci As CultureInfo
        Dim str As String
        Dim intPos As Integer
        Dim intPosDefault As Integer
        Dim intFound As Integer
        For Each ci In CultureInfo.GetCultures(CultureTypes.SpecificCultures)
            str = ci.DisplayName
            intPosDefault = InStr(str, "(")
            str = Mid(str, intPosDefault + 1, Len(str) - intPosDefault - 1)
            intPos = InStr(str, "(")
            If intPos > 0 Then
                str = Mid(str, intPos + 1, Len(str) - intPos)
            End If

            intFound = Country.FindStringExact(str)
            If Not intFound > 0 Then
                Country.Items.Add(str)
            End If
            Country.Sorted() = True
        Next ci
        Country.Text = DEFAULT_COUNTRY

    End Sub
    Public Sub PullCategories(ByVal cbo As ComboBox)
        Dim Cons As OleDb.OleDbConnection = New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & My.Settings.DBConn.ToString)
        ' cbo.Items.Clear()
        Dim SQL As OleDb.OleDbCommand = New OleDb.OleDbCommand("Select * FROM tblCategories", Cons)
        Cons.Open()
        Dim Reader As OleDb.OleDbDataReader = SQL.ExecuteReader()
        Do While Reader.Read
            If Not cbo.Items.Contains(Reader("Category").ToString) = True Then
                cbo.Items.Add(Reader("Category").ToString)
            End If
        Loop
        Cons.Close()
    End Sub
    Public Sub PullCategories(ByVal cbo As ToolStripComboBox)
        Dim Cons As OleDb.OleDbConnection = New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & My.Settings.DBConn.ToString)
        ' cbo.Items.Clear()
        Dim SQL As OleDb.OleDbCommand = New OleDb.OleDbCommand("Select * FROM tblCategories", Cons)
        Cons.Open()
        Dim Reader As OleDb.OleDbDataReader = SQL.ExecuteReader()
        Do While Reader.Read
            If Not cbo.Items.Contains(Reader("Category").ToString) = True Then
                cbo.Items.Add(Reader("Category").ToString)
            End If
        Loop
        Cons.Close()
    End Sub
#Region " Listview Functions "
    Public Function SelectedListViewListIndex(ByRef lvwView As ListView, ByVal e As System.EventArgs) As Integer
        '==============================================================================
        ' Purpose      :  Show the selected ListIndex
        ' Inputs       :  ListView e
        ' Returns      :  Shows the selected ListIndex
        ' Calls        :  = SelectedListViewListIndex(ListView, e) ' mod_ListView
        ' Use in       :  Any Procedure or _SelectedIndexChanged Event
        ' Date/Time    :  Monday, May 26, 2003 10:25:10 AM
        '==============================================================================

        With lvwView
            .MultiSelect = False
            If .SelectedIndices.Count > 0 Then
                Return .SelectedIndices(0)
            Else
                Return -1
            End If
        End With

    End Function

#Region " Search Listview "
#Region " Search ListView By Column "
    Public Sub SearchListViewColumn(ByRef lvwView As ListView, ByVal sSearchText As String, _
     ByVal Column As Byte, Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  Search a ListView Column, highlighting all matches
        ' Inputs       :  ListView, sSearchText, lColumn
        ' Returns      :  HighLights all found Items in ListView Column
        ' Calls        :  SearchListViewColumn(ListView, sSearchText, Column) ' mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Wednesday, October 22, 2003 9:46:52 PM
        '==============================================================================
        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = True

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = 0 To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If Column = 0 Then
                        If .Items(x).Text Like sSearchText _
                         And Len(.Items(x).Text) = Len(sSearchText) Then
                            .Items(x).Selected = True
                            .Items(x).EnsureVisible()
                        End If
                    ElseIf Column > 0 Then
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase
                    If Column = 0 Then
                        If .Items(x).Text.ToLower Like sSearchText.ToLower _
                         And Len(.Items(x).Text) = Len(sSearchText) Then ' Search Item
                            .Items(x).Selected = True
                            .Items(x).EnsureVisible()
                        End If
                    ElseIf Column > 0 Then
                        For Column = 1 To Columns ' Search SubItems
                            If .Items(x).SubItems(Column).Text.ToLower Like sSearchText.ToLower _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If
                End If
            Next

            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#Region " Search Entire ListView "
    Public Sub SearchListView(ByRef lvwView As ListView, ByVal sSearchText As String, _
     Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  HighLight all found Items in ListView
        ' Inputs       :  ListView, sSearchText
        ' Returns      :  HighLights all found Items in ListView
        ' Calls        :  SearchListView(ListView, sSearchText) ' mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Sunday, May 25, 2003  10:50:12 PM
        '==============================================================================

        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Column As Byte = 0
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = True

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = 0 To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If .Items(x).Text Like sSearchText _
                     And Len(.Items(x).Text) = Len(sSearchText) Then
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                    Else
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase

                    If .Items(x).Text.ToLower Like sSearchText.ToLower _
                     And Len(.Items(x).Text) = Len(sSearchText) Then ' Search Item
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                    Else
                        For Column = 1 To Columns ' Search SubItems
                            If .Items(x).SubItems(Column).Text.ToLower Like sSearchText.ToLower _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If
                End If
            Next

            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#Region " Search For Closest Match In ListView Column "
    Public Sub SearchForClosestMatchInListViewColumn(ByRef lvwView As ListView, ByVal sSearchText As String, _
     ByVal Column As Byte, Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  Search and highlight all matches in ListView Column
        ' Inputs       :  ListView, sSearchText, lColumn
        ' Returns      :  HighLights all matching Items in ListView Column
        ' Calls        :  SearchForClosestMatchInListViewColumn(ListView, sSearchText, Column)  mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Sunday, May 25, 2003  10:50:12 PM
        '==============================================================================
        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = True

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = 0 To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If Column = 0 Then
                        If .Items(x).Text Like sSearchText Then
                            .Items(x).Selected = True
                            .Items(x).EnsureVisible()
                        End If
                    ElseIf Column > 0 Then
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase
                    If Column = 0 Then
                        If InStr(.Items(x).Text.ToLower, sSearchText.ToLower) Then ' Search Item
                            .Items(x).Selected = True
                            .Items(x).EnsureVisible()
                        End If
                    ElseIf Column > 0 Then
                        For Column = 1 To Columns ' Search SubItems
                            If InStr(.Items(x).SubItems(Column).Text.ToLower, sSearchText.ToLower) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If
                End If
            Next

            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#Region " Search For Closest Match In ListView "
    Public Sub SearchForClosestMatchInListView(ByRef lvwView As ListView, ByVal sSearchText As String, _
     Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  HighLight all matching Items and SubItems in ListView
        ' Inputs       :  ListView, sSearchText, lColumn
        ' Returns      :  HighLights all matching Items and SubItems in ListView
        ' Calls        :  SearchForClosestMatchInListView(ListView, sSearchText) ' mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Sunday, May 25, 2003  10:50:12 PM
        '==============================================================================

        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Column As Byte = 0
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = True

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = 0 To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If .Items(x).Text Like sSearchText Then
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                    Else
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase

                    If InStr(.Items(x).Text.ToLower, sSearchText.ToLower) Then  ' Search Item
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                    Else
                        For Column = 1 To Columns ' Search SubItems
                            If InStr(.Items(x).SubItems(Column).Text.ToLower, sSearchText.ToLower) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                            End If
                        Next
                    End If
                End If
            Next

            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#Region " Find First Item Or SubItem In ListView "
    Public Sub FindFirstItemOrSubItemInListView(ByRef lvwView As ListView, ByVal sSearchText As String, _
     Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  Find first Item or SubItem in a ListView
        ' Inputs       :  ListView, sSearchText
        ' Returns      :  Finds and highlights first Item or SubItem found
        ' Calls        :  FindFirstItemOrSubItemInListView(ListView, sSearchText) ' mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Sunday, May 25, 2003  10:50:12 PM
        '==============================================================================

        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Column As Byte = 0
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = False

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = 0 To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If .Items(x).Text Like sSearchText _
                     And Len(.Items(x).Text) = Len(sSearchText) Then
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                        GoTo FoundIt
                    Else
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                                GoTo FoundIt
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase

                    If .Items(x).Text.ToLower Like sSearchText.ToLower _
                     And Len(.Items(x).Text) = Len(sSearchText) Then ' Search Item
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                        GoTo FoundIt
                    Else
                        For Column = 1 To Columns ' Search SubItems
                            If .Items(x).SubItems(Column).Text.ToLower Like sSearchText.ToLower _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                                GoTo FoundIt
                            End If
                        Next
                    End If
                End If
            Next
FoundIt:
            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#Region " Find Next Item Or SubItem In ListView "
    Public Sub FindNextItemOrSubItemInListView(ByRef lvwView As ListView, ByVal sSearchText As String, _
     ByVal Index As Integer, Optional ByVal bMatchCase As Boolean = False)
        '==============================================================================
        ' Purpose      :  Find next Item or SubItem in ListView
        ' Inputs       :  ListView, sSearchText
        ' Returns      :  HighLights next Item or SubItem in ListView
        ' Calls        :  FindNextItemOrSubItemInListView(ListView, sSearchText) ' mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Sunday, May 25, 2003  10:50:12 PM
        '==============================================================================

        On Error GoTo Error_ErrHandler

        Dim x As Integer = 0
        Dim Columns As Byte = lvwView.Columns.Count - 1
        Dim Column As Byte = 0
        Dim Item As ListViewItem

        If Len(sSearchText) = 0 Then Exit Sub

        With lvwView
            .BeginUpdate()
            .FullRowSelect = True
            .MultiSelect = False

            For Each Item In .SelectedItems
                Item.Selected = False
            Next

            For x = Index To .Items.Count - 1
                If bMatchCase = True Then ' Search Item using MatchCase
                    If .Items(x).Text Like sSearchText _
                     And Len(.Items(x).Text) = Len(sSearchText) Then
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                        GoTo FoundIt
                    Else
                        For Column = 0 To Columns ' Search SubItems using MatchCase
                            If .Items(x).SubItems(Column).Text Like sSearchText _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                                GoTo FoundIt
                            End If
                        Next
                    End If

                ElseIf bMatchCase = False Then ' Search without MatchCase

                    If .Items(x).Text.ToLower Like sSearchText.ToLower _
                     And Len(.Items(x).Text) = Len(sSearchText) Then ' Search Item
                        .Items(x).Selected = True
                        .Items(x).EnsureVisible()
                        GoTo FoundIt
                    Else
                        For Column = 1 To Columns ' Search SubItems
                            If .Items(x).SubItems(Column).Text.ToLower Like sSearchText.ToLower _
                             And Len(.Items(x).SubItems(Column).Text) = Len(sSearchText) Then
                                .Items(x).Selected = True
                                .Items(x).EnsureVisible()
                                GoTo FoundIt
                            End If
                        Next
                    End If
                End If
            Next
FoundIt:
            .Focus()
            .EndUpdate()
        End With

        Exit Sub
Error_ErrHandler:

    End Sub
#End Region
#End Region


#Region " Load & Save Listview "
    Public Sub SaveListViewAsBasicListViewFile(ByRef lvwView As ListView, ByVal sFileName As String)
        '==============================================================================
        ' Purpose      :  Save Listview file as a basic Listview file
        ' Inputs       :  ListViewName sFileName
        ' Returns      :  Saves ListView as a file
        ' Note         :  BASIC means file is for a basic ListView
        '              :  No ColummnHeader Titles, or Padded formmating of Items or SubItems
        ' Calls        :  SaveListViewAsBasicListViewFile(ListViewName, sFileName)
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Friday, May 23, 2003  3:07:42 PM
        '==============================================================================

        Dim x As Integer
        Dim i As Integer
        Dim lSubItems As Integer
        Dim sSubItem As String
        Dim FileNum As Integer
        FileNum = FreeFile()
        Const Delimiter As String = Chr(30) ' SubItems delimiter 

        Try
            ' Get the number of columns (to check if we have SubItems columns)
            lSubItems = lvwView.Columns.Count - 1
            ' If we do good, if not then we are just saving Items and not SubItems
            If lSubItems < 1 Then lSubItems = 1

            FileOpen(FileNum, sFileName, OpenMode.Output)

            For x = 0 To lvwView.Items.Count - 1
                sSubItem = lvwView.Items(x).Text & Delimiter ' Row Item

                For i = 1 To lSubItems ' Row Item and its SubItems
                    sSubItem = sSubItem & lvwView.Items(x).SubItems(i).Text & Delimiter
                Next i

                Print(FileNum, sSubItem & vbCrLf) ' Row Item and its SubItems
                sSubItem = ""
            Next x

            FileClose(FileNum)

        Catch ex As Exception
            MessageBox.Show("Error saving to file", "Save Error", MessageBoxButtons.OK)
        Finally
            FileClose(FileNum)
        End Try

    End Sub
    Public Sub LoadBasicListViewString(ByRef lvwView As ListView)
        Dim x As Integer ' SubItem counter
        Dim sItemRow As String = "" ' Item's Row 
        Dim objRow As Object ' Item row being read from file
        Dim iItem As Integer = 0 ' Item counter
        Const Delimiter As String = Chr(30) ' SubItems delimiter 

        Try
            With lvwView
                .View = View.Details ' Set ListView like VB6 ReportMode
                .Items.Clear() ' Clear ListView
                .BeginUpdate()


                objRow = Split(sItemRow, Delimiter) ' Split row's SubItems

                .Items.Add(objRow(0)) ' Add Item Column
                For x = 1 To .Columns.Count - 1 ' Add SubItem Columns
                    .Items(iItem).SubItems.Add(objRow(x))
                Next

                iItem += 1  ' Do next Item

                .EndUpdate()
            End With
        Catch ex As Exception
            MessageBox.Show("Error loading file", "File Error", MessageBoxButtons.OK)
        Finally
        End Try
    End Sub
    Public Sub LoadBasicListViewFile(ByRef lvwView As ListView, ByVal sFileName As String)
        '==============================================================================
        ' Purpose      :  Load a saved Listview file in ListView
        ' Inputs       :  ListView sFileName
        ' Returns      :  Loads Items and SubItems from saved ListView
        ' Calls        :  LoadBasicListViewFile(ListView, sFileName)  mod_ListView
        ' Use in       :  Any Procedure 
        ' Date/Time    :  Saturday, May 24, 2003  12:44:00 AM
        '==============================================================================

        Dim x As Integer ' SubItem counter
        Dim sItemRow As String = "" ' Item's Row 
        Dim objRow As Object ' Item row being read from file
        Dim FileNum As Integer = FreeFile() ' FreeFile
        Dim iItem As Integer = 0 ' Item counter
        Const Delimiter As String = Chr(30) ' SubItems delimiter 

        Try
            With lvwView
                .View = View.Details ' Set ListView like VB6 ReportMode
                .Items.Clear() ' Clear ListView
                .BeginUpdate()

                FileOpen(FileNum, sFileName, OpenMode.Input) ' Open ListView File

                Do While Not EOF(FileNum) ' Read File
                    Input(FileNum, sItemRow) ' Input = line from text file = sItemRow
                    objRow = Split(sItemRow, Delimiter) ' Split row's SubItems

                    .Items.Add(objRow(0)) ' Add Item Column
                    For x = 1 To .Columns.Count - 1 ' Add SubItem Columns
                        .Items(iItem).SubItems.Add(objRow(x))
                    Next

                    iItem += 1  ' Do next Item
                Loop
                .EndUpdate()
            End With

            FileClose(FileNum)

        Catch ex As Exception
            MessageBox.Show("Error loading file", "File Error", MessageBoxButtons.OK)
        Finally
            FileClose(FileNum)
        End Try

    End Sub
#End Region
#End Region

End Module
